{-# LANGUAGE DataKinds #-}
{-# LANGUAGE TypeFamilies #-}
{-# LANGUAGE InstanceSigs #-}
{-# LANGUAGE LambdaCase #-}
module Language.Java.Classfile.ClassFlag (ClassFlag(..)) where
import Data.Word (Word16)
import Language.Java.Classfile.Flag (FlagMask (..))

data ClassFlag
  = Public
  | Final
  | Super
  | Interface
  | Abstract
  | Synthetic
  | Annotation
  | Enum
  | Module
  deriving (Show, Eq, Ord, Enum, Bounded)

instance FlagMask ClassFlag where
  type FlagType ClassFlag = Word16
  maskOf :: ClassFlag -> FlagType ClassFlag
  maskOf = \case
    Public     -> 0x0001
    Final      -> 0x0010
    Super      -> 0x0020
    Interface  -> 0x0200
    Abstract   -> 0x0400
    Synthetic  -> 0x1000
    Annotation -> 0x2000
    Enum       -> 0x4000
    Module     -> 0x8000
