{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE InstanceSigs #-}
{-# LANGUAGE TypeApplications #-}
{-# LANGUAGE ScopedTypeVariables #-}
module Language.Java.Classfile.Extractable.SizedBytes (SizedBytes(..)) where
import Data.ByteString (ByteString)
import Language.Java.Classfile.Extractable (Extractable (..))
import Language.Java.Classfile.Extract (Extract, bytes)
import qualified Data.ByteString as StrictByteString
import qualified Data.ByteString.Lazy as ByteString

newtype SizedBytes sizeType = SizedBytes ByteString
  deriving stock Show

instance (Extractable sizeType, Integral sizeType) => Extractable (SizedBytes sizeType) where
  extract :: Extract (SizedBytes sizeType)
  extract = do
    size <- extract @sizeType
    SizedBytes . StrictByteString.concat . ByteString.toChunks <$> bytes (fromIntegral size)

